// STM8uLoader.cs
using System;
using System.IO;
using System.IO.Ports;
using System.Threading;
using System.Collections.Generic;

public class STM8uLoader
{
	
	public static void Main()   { 

		//Dumps	myDumps = new Dumps();

		Dumps.COM_port_Open();
		readThread = new Thread(Dumps.Read);
		readThread.IsBackground = true; // не позволит остаться потоку в памяти после закрытия программы ?
			try {
				readThread.Start();		// запускаем поток чтения COM порта
			} catch (Exception ex) {Console.WriteLine(" readThread.Start(). Exception" + ex.Message); } 
					
		Dumps.Load_First_Dump(Dumps.Read_128000v14);

		blckAdr = 0x9FFE;	blckSize = 2;
		Console.WriteLine(" Адрес прикладной программы");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));

		blckAdr = 0x8000;	blckSize = 4;
		Console.WriteLine(" Начальный копировщик boot_FLASH");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));

		blckAdr = 0x0000;	blckSize = 53;
		Console.WriteLine(" Код загрузчика boot_OPTION");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		Dumps.Load_Dump(Dumps.Read_128000v14);
		
		blckAdr = 0x4800;	blckSize = 64;
		Console.WriteLine(" OPTION Bytes и образ кода загрузчика boot_OPTION");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		blckAdr = 0x9FE0;	blckSize =32;
		Console.WriteLine(" Код начального копировщика boot_FLASH");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		blckAdr = 0xA000;	blckSize =64;
		Console.WriteLine(" Заглянем за \"горизонт\"");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		readThread.Join();	// останавливаем поток чтения COM порта
		Dumps.COM_port_Close();
		Console.ReadKey(); return;
    } // Main();
    public static Thread readThread;

	public static string stringMemoryMap = "";
	public  static byte rx_byte = 0x00;
	public static byte[] btBytes = new byte[1];
	public static byte[] wrd4Bytes = new byte[4];
	public static byte[] blck64Bytes = new byte[64];
	public static int blckAdr;
	public static int blckSize;
	public  static bool unready = true;
	public  static string fileName;	
	public static byte[] txBytes = {0, 0};

}// class STM8uLoader
// STM8uLoader.cs